# -*- sh -*-
# GraceGTK command file
@ Version 1000905

# input set is given an alias name
@ alias "signal" s$
# Temporary string variable
@ define legname = legend s$
# Permanent sets must be created first
@ DEFINE NEW SET result IN g0

# Than we create 3 temporary sets
@ DEFINE NEW SET tmp1 IN g$
@ DEFINE NEW SET tmp2 IN g$
@ DEFINE NEW SET tmp3 IN g$
@ copy signal to tmp1
@ copy signal to tmp2
@ copy signal to tmp3

# Fitting of the periodic noise will be performed 
# only in a region where the signal is negligible
@ restrict (tmp1 ,x<0.01 || x>0.088)

# We use the values below to start the fit 
@ a0 = 0.25 
@ a1 = 0.15  
@ a2 = 0.20  
@ a3 = 50. 
@ a4 = 3.0  
@ a5 = 0.1  
@ a6 = 150 
@ a7 = 1.0
# Here, the point is used to concatenate two strings
@ fit formula "y=".sine_noise
@ fit with 8 parameters
@ fit prec 0.010000
@ fit max steps 50
#   and actually fit the periodic noise
@ nonlfit (tmp1 ,50)

# now a0,.. a7 are fitted, we compute the periodic noise values
# tmp1 is restricted, thus have no longer the good number
#      of points: we evaluate formula in tmp2
# Nothing else than evaluate() is allowed in the line below
@ tmp2.y = EVALUATE(sine_noise)

# substract the periodic noise to signal
@ tmp3.y = tmp3.y - tmp2.y

# We try to filter the white noise
@ FILTER BUTTERWORTH ( tmp3 ,result ,"lp" ,5 ,500 ,0.25 ,off ) 
# @ FILTER WAVELET (tmp3 ,result ,DAUBECHIES ,1 ,4 ,0.005)
@ result LEGEND "Fit ".legname

# An example of using a IF: only signal 1 (S0) will be visible
@ if (signal.id > 0) {
@   signal hidden on
@ }

# We now clear the temporary sets in reverse order
# of their creation to wipe all trace of them
@ clear tmp3
@ clear tmp2
@ clear tmp1
# and forget settype variables (but the sets are not killed
# an remains accessible by numbering
@ forget result
@ forget signal
# then, clear the temporary variable
@ clear legname

@ UPDATEALL


